//===========================================================================
// Simulationsbeispiel
//===========================================================================

// mehrfaches Einbinden durch Prprozessor verhindern
#ifndef _PARTICLE_H_
#define _PARTICLE_H_

// Vektoren einbinden
#include "vertex.h"

// Partikelklasse
class CParticle
{
  // Nachfolgende Elemente sind ffentlich
  public:

    /// Konstruktor
    CParticle();

    /// Destruktor virtuell, d.h. alles bereit zum Ableiten
    virtual ~CParticle();

    /// Partikel an Position verschieben
    void moveTo(CVertex position);

    /// Kraft auf Partikel wirken lassen
    void addForce(CVertex force);

    /// Auf einen Punkt zubewegen
    void accelerateTowards(CVertex destination, Coord accelerationFactor);

    /// Auf einen Punkt zubewegen, proportional dem Abstand zum Punkt
    void accelerateProportional(CVertex destination, Coord accelerationFactor);

    /// Partikelsimulation mit Zeitschritt und Luftwiderstand aktualisieren
    void update(Coord timeStep, Coord airFriction);

    /// Partikelposition zurckliefern
    CVertex position() const;

  // Nachfolgende Elemente sind geschtzt
  protected:

    CVertex m_position;     ///< Position des Partikels
    CVertex m_velocity;     ///< Geschwindigkeit des Partikels
    CVertex m_acceleration; ///< Beschleunigung des Partikels

}; // Klassendeklaration auch mit Semikolon abschlieen

#endif // _PARTICLE_H_
